<?php

/**
 * This Software is the property of Data Development and is protected
 * by copyright law - it is NOT Freeware.
 * Any unauthorized use of this software without a valid license
 * is a violation of the license agreement and will be prosecuted by
 * civil and criminal law.
 * http://www.shopmodule.com
 *
 * @copyright (C) D3 Data Development (Inh. Thomas Dartsch)
 * @author        D3 Data Development - Daniel Seifert <ds@shopmodule.com>
 * @link          http://www.oxidmodule.com
 */
class d3_delarticles_update extends d3install_updatebase
{

    public $sModKey = 'd3delarticles';

    public $sModName = 'Artikel Lschen';

    public $sModVersion = '3.0.1.1';

    public $sModRevision = '70';

    public $sBaseConf = 'qWqZWcyYVp2MGRuR2hnWWkzMjFBK2tIQzltSWFza0xIUXVUd3lhdXJCa2VTYm1IR1hRUFFuUThVYU5BV
3gvZHNiSmRPRlRLWmFpZ1NPRkVmaVlqMnh5c0NiSUc1OGd5amRlN1dXaE9sOFZMTWhUalU0NHNvb0I4T
GxxRTJkM2ozaTQ4c0JBcUJXaDU0d3lnUE5BQm1aYzVZV05ZQkpCWUtBOGNTWTBVZUVOaGxtVTFaWmtWR
TlQZ3VaYS81MTh1Zm5Bb3NVRXowcGJCMUcvRzdyY01kM1lISk5zTFlxOG83QmplOU5neXQ0QVo0MGR1c
TJpaVRMY2h2b2dhSnZGaGM2R3E3NERtUEg5VFRoTFEwT2I2RnppeUczVHNHTmd5bW5udzRBQlVIUFNMc
mM9';

    public $sRequirements = '<?xml version="1.0" encoding="UTF-8"?>
      <jobs>
        <database>
          <table name="d3_cfg_mod" />
          <table name="oxarticles" />
        </database>
        <dependencies>
                <dependency modid="d3modcfg_lib" minrevision="676" />
                <dependency modid="d3install_lib" minrevision="468" />
        </dependencies>
      </jobs>';

    public $sBaseValue = '';

    protected $_aUpdateMethods = array(
        array(
            'check' => 'checkModCfgItemExist',
            'do'    => 'updateModCfgItemExist'
        ),
        array(
            'check' => 'hasOldModuleFiles',
            'do'    => 'deleteOldModuleFiles'
        ),
        array(
            'check' => 'checkModCfgSameRevision',
            'do'    => 'updateModCfgSameRevision'
        ),
    );

    protected $_aRefreshMetaModuleIds = array('d3delarticles');

    public $aOldModuleFiles = array(
        'd3/d3delarticles/models/d3_delarticles_update.php',
    );

    /**
     * @return bool
     */
    public function checkModCfgItemExist()
    {
        $blRet = false;
        foreach ($this->getShopList() as $oShop) {
            /** @var $oShop oxshop */
            $aWhere = array(
                'oxmodid'       => $this->sModKey,
                'oxnewrevision' => $this->sModRevision,
                'oxshopid'      => $oShop->getId(),
            );

            $blRet = $this->_checkTableItemNotExist('d3_cfg_mod', $aWhere);
        }

        return $blRet;
    }

    /**
     * @return bool
     */
    public function updateModCfgItemExist()
    {
        $blRet = false;

        if ($this->checkModCfgItemExist()) {
            foreach ($this->getShopList() as $oShop) {
                /** @var $oShop oxshop */
                $aWhere = array(
                    'oxmodid'       => $this->sModKey,
                    'oxshopid'      => $oShop->getId(),
                );

                $aInsertFields = array(
                    'OXID'           => array(
                        'content'      => "md5('" . $this->sModKey . " " . $oShop->getId() . " de')",
                        'force_update' => true,
                        'use_quote'    => false,
                    ),
                    'OXSHOPID'       => array(
                        'content'      => $oShop->getId(),
                        'force_update' => true,
                        'use_quote'    => true,
                    ),
                    'OXMODID'        => array(
                        'content'      => $this->sModKey,
                        'force_update' => true,
                        'use_quote'    => true,
                    ),
                    'OXNAME'         => array(
                        'content'      => $this->sModName,
                        'force_update' => true,
                        'use_quote'    => true,
                    ),
                    'OXACTIVE'       => array(
                        'content'      => "0",
                        'force_update' => false,
                        'use_quote'    => false,
                    ),
                    'OXBASECONFIG'   => array(
                        'content'      => $this->sBaseConf,
                        'force_update' => true,
                        'use_quote'    => true,
                    ),
                    'OXINSTALLDATE'  => array(
                        'content'      => "NOW()",
                        'force_update' => true,
                        'use_quote'    => false,
                    ),
                    'OXVERSION'      => array(
                        'content'      => $this->sModVersion,
                        'force_update' => true,
                        'use_quote'    => true,
                    ),
                    'OXSHOPVERSION'  => array(
                        'content'      => oxRegistry::getConfig()->getEdition(),
                        'force_update' => true,
                        'use_quote'    => true,
                    ),
                    'OXREQUIREMENTS' => array(
                        'content'      => $this->sRequirements,
                        'force_update' => true,
                        'use_quote'    => true,
                    ),
                    'OXVALUE'        => array(
                        'content'      => $this->sBaseValue,
                        'force_update' => false,
                        'use_quote'    => true,
                    ),
                    'OXNEWREVISION'  => array(
                        'content'      => $this->sModRevision,
                        'force_update' => true,
                        'use_quote'    => true,
                    )
                );
                $aRet          = $this->_updateTableItem('d3_cfg_mod', $aInsertFields, $aWhere);
                $blRet         = $aRet['blRet'];

                $this->_setActionLog('SQL', $aRet['sql'], __METHOD__);
                $this->_setUpdateBreak(false);

                if ($this->getStepByStepMode()) {
                    break;
                }
            }
        }

        return $blRet;
    }

    /**
     * @return bool
     */
    public function checkModCfgSameRevision()
    {
        return $this->_checkModCfgSameRevision($this->sModKey);
    }

    /**
     * @return bool
     */
    public function updateModCfgSameRevision()
    {
        $blRet = false;

        if ($this->checkModCfgSameRevision($this->sModKey)) {
            $aRet = $this->_updateModCfgSameRevision($this->sModKey);

            $this->_setActionLog('SQL', $aRet['sql'], __METHOD__);
            $this->_setUpdateBreak(false);
            $blRet = $aRet['blRet'];
        }

        return $blRet;
    }
}